; Mouse driver bindings
; Jan Wassenberg 2000

global reset_mouse
global show_mouse
global hide_mouse
global mouse_x
global mouse_in_rect
global get_left_clicks


section CODE use16

; Helper macro for mouse driver interrupts
; %1 - Function code
; %2 - Register to copy to ax
; %3 - no_RET to avoid RET
%macro mouse_int 1-3 ax  
	mov	ax, %1
	int	0x33
%ifnidni %2, ax				; Need to copy return value?
	mov	ax, %2
%endif
%ifnidni %3, no_Ret
	ret
%endif
%endmacro

reset_mouse:
	mouse_int 0

show_mouse:
	mouse_int 1

hide_mouse:
	mouse_int 2

mouse_x:				; Returns mouse X position
	mouse_int 3, cx

mouse_in_rect:				; Mouse within rectangle?
	push	bp
	mov	bp, sp			; Stack frame

	mouse_int 3, ax, no_RET

	xor	al, al
	cmp	dx, [bp+4]		; Y2
	ja	.1
	cmp	cx, [bp+6]		; X2
	ja	.1
	cmp	dx, [bp+8]		; Y1
	jb	.1
	cmp	cx, [bp+10]		; X1
	jb	.1
	inc	al

.1:	pop	bp
	ret

get_left_clicks:			; Returns number of left clicks since last call
	xor	bx, bx
	mouse_int 5, bx